/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

    package com.ywt.gapi.taihe.register;

import org.apache.dubbo.common.stream.StreamObserver;
import com.google.protobuf.Message;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.concurrent.CompletableFuture;

public interface TaiheRegisterService extends org.apache.dubbo.rpc.model.DubboStub {

    String JAVA_SERVICE_NAME = "com.ywt.gapi.taihe.register.TaiheRegisterService";
    String SERVICE_NAME = "com.ywt.gapi.taihe.register.TaiheRegisterService";

        /**
         * <pre>
         * 医生职称
         * </pre>
         */
    com.ywt.gapi.taihe.register.CreateRegisteredResponse createRegistered(com.ywt.gapi.taihe.register.CreateRegisteredRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.CreateRegisteredResponse> createRegisteredAsync(com.ywt.gapi.taihe.register.CreateRegisteredRequest request){
        return CompletableFuture.completedFuture(createRegistered(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void createRegistered(com.ywt.gapi.taihe.register.CreateRegisteredRequest request, StreamObserver<com.ywt.gapi.taihe.register.CreateRegisteredResponse> responseObserver){
        createRegisteredAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 科室Code
         * </pre>
         */
    com.ywt.gapi.taihe.register.CancelRegisteredResponse cancelRegistered(com.ywt.gapi.taihe.register.CancelRegisteredRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.CancelRegisteredResponse> cancelRegisteredAsync(com.ywt.gapi.taihe.register.CancelRegisteredRequest request){
        return CompletableFuture.completedFuture(cancelRegistered(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void cancelRegistered(com.ywt.gapi.taihe.register.CancelRegisteredRequest request, StreamObserver<com.ywt.gapi.taihe.register.CancelRegisteredResponse> responseObserver){
        cancelRegisteredAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 科室名称
         * </pre>
         */
    com.ywt.gapi.taihe.register.PayCallbackResponse payCallback(com.ywt.gapi.taihe.register.PayCallbackRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.PayCallbackResponse> payCallbackAsync(com.ywt.gapi.taihe.register.PayCallbackRequest request){
        return CompletableFuture.completedFuture(payCallback(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void payCallback(com.ywt.gapi.taihe.register.PayCallbackRequest request, StreamObserver<com.ywt.gapi.taihe.register.PayCallbackResponse> responseObserver){
        payCallbackAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 医生Code
         * </pre>
         */
    com.ywt.gapi.taihe.register.RefundCallbackResponse refundCallback(com.ywt.gapi.taihe.register.RefundCallbackRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.RefundCallbackResponse> refundCallbackAsync(com.ywt.gapi.taihe.register.RefundCallbackRequest request){
        return CompletableFuture.completedFuture(refundCallback(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void refundCallback(com.ywt.gapi.taihe.register.RefundCallbackRequest request, StreamObserver<com.ywt.gapi.taihe.register.RefundCallbackResponse> responseObserver){
        refundCallbackAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 医生名称
         * </pre>
         */
    com.ywt.gapi.taihe.register.RegisterResponse register(com.ywt.gapi.taihe.register.RegisterRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.RegisterResponse> registerAsync(com.ywt.gapi.taihe.register.RegisterRequest request){
        return CompletableFuture.completedFuture(register(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void register(com.ywt.gapi.taihe.register.RegisterRequest request, StreamObserver<com.ywt.gapi.taihe.register.RegisterResponse> responseObserver){
        registerAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 预约挂号总费用
         * </pre>
         */
    com.ywt.gapi.taihe.register.TakeResponse take(com.ywt.gapi.taihe.register.TakeRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.TakeResponse> takeAsync(com.ywt.gapi.taihe.register.TakeRequest request){
        return CompletableFuture.completedFuture(take(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void take(com.ywt.gapi.taihe.register.TakeRequest request, StreamObserver<com.ywt.gapi.taihe.register.TakeResponse> responseObserver){
        takeAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 挂号费
         * </pre>
         */
    com.ywt.gapi.taihe.register.GetQueueListResponse getQueueList(com.ywt.gapi.taihe.register.GetQueueListRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.GetQueueListResponse> getQueueListAsync(com.ywt.gapi.taihe.register.GetQueueListRequest request){
        return CompletableFuture.completedFuture(getQueueList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getQueueList(com.ywt.gapi.taihe.register.GetQueueListRequest request, StreamObserver<com.ywt.gapi.taihe.register.GetQueueListResponse> responseObserver){
        getQueueListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 诊查费
         * </pre>
         */
    com.ywt.gapi.taihe.register.GetCommonOrderListResponse getCommonOrderList(com.ywt.gapi.taihe.register.GetCommonOrderListRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.GetCommonOrderListResponse> getCommonOrderListAsync(com.ywt.gapi.taihe.register.GetCommonOrderListRequest request){
        return CompletableFuture.completedFuture(getCommonOrderList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getCommonOrderList(com.ywt.gapi.taihe.register.GetCommonOrderListRequest request, StreamObserver<com.ywt.gapi.taihe.register.GetCommonOrderListResponse> responseObserver){
        getCommonOrderListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 预约日期
         * </pre>
         */
    com.ywt.gapi.taihe.register.GetRegisteredListResponse getRegisteredList(com.ywt.gapi.taihe.register.GetRegisteredListRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.GetRegisteredListResponse> getRegisteredListAsync(com.ywt.gapi.taihe.register.GetRegisteredListRequest request){
        return CompletableFuture.completedFuture(getRegisteredList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getRegisteredList(com.ywt.gapi.taihe.register.GetRegisteredListRequest request, StreamObserver<com.ywt.gapi.taihe.register.GetRegisteredListResponse> responseObserver){
        getRegisteredListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 预约时间段
         * </pre>
         */
    com.ywt.gapi.taihe.register.RegisterWithoutMedicalCardResponse registerWithoutMedicalCard(com.ywt.gapi.taihe.register.RegisterWithoutMedicalCardRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.RegisterWithoutMedicalCardResponse> registerWithoutMedicalCardAsync(com.ywt.gapi.taihe.register.RegisterWithoutMedicalCardRequest request){
        return CompletableFuture.completedFuture(registerWithoutMedicalCard(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void registerWithoutMedicalCard(com.ywt.gapi.taihe.register.RegisterWithoutMedicalCardRequest request, StreamObserver<com.ywt.gapi.taihe.register.RegisterWithoutMedicalCardResponse> responseObserver){
        registerWithoutMedicalCardAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 预约开始时间：HH:MI
         * </pre>
         */
    com.ywt.gapi.taihe.register.GetOfflineConsultInfoByDoctorIdResponse getOfflineConsultInfoByDoctorId(com.ywt.gapi.taihe.register.GetOfflineConsultInfoByDoctorIdRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.GetOfflineConsultInfoByDoctorIdResponse> getOfflineConsultInfoByDoctorIdAsync(com.ywt.gapi.taihe.register.GetOfflineConsultInfoByDoctorIdRequest request){
        return CompletableFuture.completedFuture(getOfflineConsultInfoByDoctorId(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getOfflineConsultInfoByDoctorId(com.ywt.gapi.taihe.register.GetOfflineConsultInfoByDoctorIdRequest request, StreamObserver<com.ywt.gapi.taihe.register.GetOfflineConsultInfoByDoctorIdResponse> responseObserver){
        getOfflineConsultInfoByDoctorIdAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 预约结束时间：HH:MI
         * </pre>
         */
    com.ywt.gapi.taihe.register.GetLatestRegOrderResponse getLatestRegOrder(com.ywt.gapi.taihe.register.GetLatestRegOrderRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.GetLatestRegOrderResponse> getLatestRegOrderAsync(com.ywt.gapi.taihe.register.GetLatestRegOrderRequest request){
        return CompletableFuture.completedFuture(getLatestRegOrder(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getLatestRegOrder(com.ywt.gapi.taihe.register.GetLatestRegOrderRequest request, StreamObserver<com.ywt.gapi.taihe.register.GetLatestRegOrderResponse> responseObserver){
        getLatestRegOrderAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 用户ID
         * </pre>
         */
    com.ywt.gapi.taihe.register.CalAdditionalFeeResponse calAdditionalFee(com.ywt.gapi.taihe.register.CalAdditionalFeeRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.CalAdditionalFeeResponse> calAdditionalFeeAsync(com.ywt.gapi.taihe.register.CalAdditionalFeeRequest request){
        return CompletableFuture.completedFuture(calAdditionalFee(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void calAdditionalFee(com.ywt.gapi.taihe.register.CalAdditionalFeeRequest request, StreamObserver<com.ywt.gapi.taihe.register.CalAdditionalFeeResponse> responseObserver){
        calAdditionalFeeAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 诊疗卡ID
         * </pre>
         */
    com.ywt.gapi.taihe.register.GetHisPatientIdByUserIdAndMobileResponse getHisPatientIdByUserIdAndMobile(com.ywt.gapi.taihe.register.GetHisPatientIdByUserIdAndMobileRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.GetHisPatientIdByUserIdAndMobileResponse> getHisPatientIdByUserIdAndMobileAsync(com.ywt.gapi.taihe.register.GetHisPatientIdByUserIdAndMobileRequest request){
        return CompletableFuture.completedFuture(getHisPatientIdByUserIdAndMobile(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getHisPatientIdByUserIdAndMobile(com.ywt.gapi.taihe.register.GetHisPatientIdByUserIdAndMobileRequest request, StreamObserver<com.ywt.gapi.taihe.register.GetHisPatientIdByUserIdAndMobileResponse> responseObserver){
        getHisPatientIdByUserIdAndMobileAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 门诊排班项记录标识
         * </pre>
         */
    com.ywt.gapi.taihe.register.CreateMedicalCardResponse createMedicalCard(com.ywt.gapi.taihe.register.CreateMedicalCardRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.CreateMedicalCardResponse> createMedicalCardAsync(com.ywt.gapi.taihe.register.CreateMedicalCardRequest request){
        return CompletableFuture.completedFuture(createMedicalCard(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void createMedicalCard(com.ywt.gapi.taihe.register.CreateMedicalCardRequest request, StreamObserver<com.ywt.gapi.taihe.register.CreateMedicalCardResponse> responseObserver){
        createMedicalCardAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 支付渠道
         * </pre>
         */
    com.ywt.gapi.taihe.register.RegisterCheckInMessageResponse registerCheckInMessage(com.ywt.gapi.taihe.register.RegisterCheckInMessageRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.RegisterCheckInMessageResponse> registerCheckInMessageAsync(com.ywt.gapi.taihe.register.RegisterCheckInMessageRequest request){
        return CompletableFuture.completedFuture(registerCheckInMessage(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void registerCheckInMessage(com.ywt.gapi.taihe.register.RegisterCheckInMessageRequest request, StreamObserver<com.ywt.gapi.taihe.register.RegisterCheckInMessageResponse> responseObserver){
        registerCheckInMessageAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }






}
